<?php
/*------------------------------------------------------------------------
# mod_small_gallery - Small Gallery
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modSmallGalleryHelper
{
	function getList(&$params)
	{
		global $mainframe;

		$source		= $params->get('source', '');
		$width = $params->get('width', 60);
		$height = $params->get('height',55);
		$type = intval($params->get('type',0));
		$order = $params->get('order','name');

		$path 	= JPATH_SITE ."/".$source;
		$thumbs_path = $path."/thumbs";
		if(!is_dir($thumbs_path)){
			JFolder::create($thumbs_path,755);
		}else{
			chmod($thumbs_path,0755);
		}
		
		$images 	= JFolder::files( $path );
		if($order == 'name') asort($images);
		else shuffle($images);
		
		$lists = array();
		$thumbs = array();
		$i = 0;
		$image_helper = & ImageGalleryHelper::getInstance();
		
		foreach ($images as $image){
			$temp 	= $path .'/'. $image;
			if ( @eregi( "bmp|gif|jpg|png|jpeg", $image ) && is_file( $temp ) ) {
				$img = JURI::base().$source."/".$image;
				$thumb_src = JURI::base().$source."/thumbs/".$image;
				$thumb = $thumbs_path."/".$image;
				$item = new ImageGallery();
				$item->setImage($img);
				if($type == 0){
					if(file_exists($thumb)){
						$item->setThumb($thumb_src);
					}else{
						$item->setThumb($img);
					}
				}elseif($type == 1){
					$item->setThumb($img);					
				}elseif($type == 2){
					if(!file_exists($thumb) ||  !$image_helper->test_W_H_Image($thumb, $width, $height)) 
					{	
						$image_helper->deleteImage($thumb);
						$ext = $image_helper->getTypeIcon($image);
						$image_helper->create_crop($img, $thumb, $ext, $width, $height);
					}
					$item->setThumb($thumb_src);
				}
				$lists[$i] = $item;
				$i++;
			}
		}
		
		return $lists;
	}
}
class ImageGallery{
	var $thumb = null;
	var $image = null;
	function setThumb($thumb){
		$this->thumb = $thumb;
	}
	function setImage($image){
		$this->image = $image;
	}
}
class ImageGalleryHelper
{	
	function __construct() {}
	function &getInstance (){
        static $instance;        
        if (!isset($instance)) {
            
            $instance = new ImageGalleryHelper();
        }         
        return $instance;        
    } 
	function isImage( $fileName ){
		static $imageTypes = 'gif|jpg|jpeg|png|bmp';
		return preg_match("/$imageTypes/i",$fileName);
	}
	function getTypeIcon( $fileName ){
		return strtolower(substr($fileName, strrpos($fileName, '.') + 1));
	}
	function create_crop($source, $destination, $extension, $crop_width, $crop_height){	
		$size=getimagesize($source);
		$width=$size[0];
		$height=$size[1];
		if ($width >= $crop_width && $height >= $crop_height)
		{
		}
		else if ($width > $crop_width && $height < $crop_height)
		{
			$crop_height = $height;
		}
		else if ($width < $crop_width && $height > $crop_height)
		{
			$crop_width = $width;
		}
		else 
		{
			$crop_height = $height;
			$crop_width = $width;			
		}
		$x=0; $y=0;
		$new_image=imagecreatetruecolor($crop_width,$crop_height) or die();		
		if($extension=="jpg" || $extension=="jpeg")
			$image=imagecreatefromjpeg($source);
		if($extension=="gif")
			$image=imagecreatefromgif($source);
		if($extension=="png")
			$image=imagecreatefrompng($source);
		// crop 
		@imagecopy($new_image,$image,0,0,$x,$y,$crop_width,$crop_height);		
		if($extension=="jpg" || $extension=="jpeg")
			imagejpeg($new_image,$destination);
		if($extension=="gif")
			imagegif($new_image,$destination);
		if($extension=="png")
			imagepng($new_image,$destination);
	}		
	function test_W_H_Image($source, $w, $h){	
		$size=getimagesize($source);
		$width=$size[0];
		$height=$size[1];
		if ($width != $w && $height != $h){
			$this->deleteImage($source);
			return false;
		}		
		else {
			return true;
		}		
	}	
	function deleteImage($imagePath){
		if(file_exists($imagePath))  
			unlink($imagePath);	
		else 
			return false;		
		return true;		
	}
}